// @TODO:   Precalculate first character
//          Better algo
//          Check between two name entries(before/after)
//          Unfold loops and stuff

#include <stdio.h>
#include <windows.h>

#include "Main.h"
#include "Algorithm.h"
#include "constants.h"

DWORD threadCount;
bool found = false;

DWORD prefixSeedA1;
DWORD prefixSeedA2;
DWORD prefixSeedB1;
DWORD prefixSeedB2;

DWORD dwMaxDepth;

DWORD dwCPUCount;
DWORD dwStartTime;

// Couldn't think of an awesome way to deal with this yet
DWORD WINAPI BruteThread(LPVOID lpParam)
{
  DWORD dwCharCount = szAfter[0] - szBefore[0] + 1;
  DWORD dwCharLimit = dwCharCount / dwCPUCount;
  DWORD dwThreadId  = (DWORD)lpParam;

  DWORD dwName[32] = { 0 };
  for ( DWORD dwFirstChr = (szBefore[0] + dwCharLimit*dwThreadId);
        (dwFirstChr < (dwThreadId != dwCPUCount ? (szBefore[0] + dwCharLimit*(dwThreadId+1)) : szAfter[0]+1) ) && !found;
        ++dwFirstChr )
  {
    DWORD dwNewSeedA1 = dwHashNameATable[dwFirstChr] ^ (prefixSeedA1 + prefixSeedA2);
    DWORD dwNewSeedA2 = dwFirstChr + dwNewSeedA1 + prefixSeedA2 + (prefixSeedA2 << 5);

    dwName[0] = dwFirstChr;
    if ( HashLoopRestricted(dwName, 1, dwNewSeedA1, dwNewSeedA2, (dwFirstChr == szBefore[0] ? 1 : 0) | (dwFirstChr == szAfter[0] ? 2 : 0)) )
      break;
    
    DWORD *pdwSuffix = szSuffix;
    while ( *(pdwSuffix+1) )
    {
      DWORD dwSuffix = *pdwSuffix++;
      dwNewSeedA1 = dwHashNameATable[dwSuffix] ^ (dwNewSeedA1 + dwNewSeedA2);
      dwNewSeedA2 = dwSuffix + dwNewSeedA1 + dwNewSeedA2 + (dwNewSeedA2 << 5);
    }
    dwNewSeedA1 = dwHashNameATable[*pdwSuffix] ^ (dwNewSeedA1 + dwNewSeedA2);

    if ( dwNewSeedA1 == dwHashA )
    {
      memcpy(&dwName[1], szSuffix, 16*4);
      if ( Found(dwName) )
        break;
    }
  }
  DWORD dwTime         = GetTickCount() - dwStartTime;
  DWORD dwSeconds      = dwTime / 1000;
  printf("Finished thread %u (%u:%02u:%03u).\n", dwThreadId, dwSeconds / 60, dwSeconds % 60, dwTime % 1000);
  --threadCount;
  return EXIT_SUCCESS;
}

DWORD szSuffix[16];
DWORD szBefore[32];
DWORD szAfter[32];
int __cdecl main(int argc, char *argv[])
{
  // Needs more parameters
  if ( argc < 5 )
  {
    if ( argc == 1 )
      InitCryptTable();
    else if ( argc == 2 )
      printf("Hashes to: 0x%08X 0x%08X\n", HashStringToA(argv[1]), HashStringToB(argv[1]));
    else
      printf( "Usage:\n"
              "        %s hashA hashB prefix suffix [nameBefore] [nameAfter]\n", argv[0]);
    return EXIT_SUCCESS;
  }
  // Obtain hashes A and B
  sscanf(argv[1], "%X", &dwHashA);
  sscanf(argv[2], "%X", &dwHashB);

  // Calculate prefix hash info
  DWORD seedA1 = 0x7FED7FED;
  DWORD seedA2 = 0xEEEEEEEE;
  DWORD seedB1 = 0x7FED7FED;
  DWORD seedB2 = 0xEEEEEEEE;
  char *prefix = argv[3];
  while ( *prefix )
  {
    int ch = toupper( *prefix++ )+3;
    seedA1 = dwHashNameATable[ch] ^ (seedA1 + seedA2);
    seedA2 = ch + seedA1 + seedA2 + (seedA2 << 5);
    seedB1 = dwHashNameBTable[ch] ^ (seedB1 + seedB2);
    seedB2 = ch + seedB1 + seedB2 + (seedB2 << 5);
  }
  prefixSeedA1 = seedA1;
  prefixSeedA2 = seedA2;
  prefixSeedB1 = seedB1;
  prefixSeedB2 = seedB2;

  for ( int i = 0; argv[4][i]; ++i )
  {
    szSuffix[i] = toupper(argv[4][i])+3;
  }

  int ibefore = 0;
  if ( argc > 5 )
    for ( ibefore = 0; argv[5][ibefore]; ++ibefore )
      szBefore[ibefore] = toupper(argv[5][ibefore])+3;
  for ( ; ibefore < 32; ++ibefore )
    szBefore[ibefore] = 'A'+3;

  int iafter = 0;
  if ( argc > 6 )
    for ( iafter = 0; argv[6][iafter]; ++iafter )
      szAfter[iafter] = toupper(argv[6][iafter])+3;
  for ( ; iafter < 32; ++iafter )
    szAfter[iafter] = 'Z'+3;

  char prefixPlus[32] = { 0 };
  int prefixi = 0;
  for ( ; prefixi < 32 && szBefore[prefixi] == szAfter[prefixi]; ++prefixi )
    prefixPlus[prefixi] = (char)szBefore[prefixi];
  for ( int i = 0; i < prefixi; ++i )
  {
    for ( int p = 0; p < 31; ++p )
    {
      szBefore[p] = szBefore[p+1];
      szAfter[p]  = szAfter[p+1];
    }
    szBefore[31] = 'A'+3;
    szAfter[31]  = 'Z'+3;
  }

  // Get start time
  dwStartTime = GetTickCount();

  // Get Processor Count
  SYSTEM_INFO sysinfo;
  GetSystemInfo( &sysinfo );
  dwCPUCount = sysinfo.dwNumberOfProcessors;

  DWORD dwCharCount = szAfter[0] - szBefore[0] + 1;
  if ( dwCharCount < dwCPUCount )
    dwCPUCount = dwCharCount;

  // Create threads
  for ( unsigned int i = 0; i < dwCPUCount && !found; ++i)
  {
    ++threadCount;
    SetThreadAffinityMask(CreateThread(NULL, 0, &BruteThread, (LPVOID)i, 0, NULL), 1 << (i % dwCPUCount));
  }
  // Wait for threads to finish
  while ( threadCount )
    Sleep(400);

  // Display time
  DWORD dwTime         = GetTickCount() - dwStartTime;
  DWORD dwSeconds      = dwTime / 1000;
  if ( found )
    printf("Found name: %s%s%s\n", argv[3], prefixPlus, szFoundStr);
  else
    printf("Found nothing.\n");
  printf("Total Time: %u:%02u:%03u\n", dwSeconds / 60, dwSeconds % 60, dwTime % 1000);
  printf("HashB calculations: %u\n", dwFalseCount);
  return EXIT_SUCCESS;
}
